#ifndef MEMORY_H
#define MEMORY_H

#define STACK_SIZE 0x00004000
#define FCRAM_BASE 0x20000000
#define TOP_ASPECT_X 0x5
#define TOP_ASPECT_Y 0x3
#define TOP_HEIGHT 240
#define TOP_WIDTH 400
#define BOTTOM_WIDTH 320
#define FRAMEBUFFER_SEL 0x20184E59
#define TOP_LEFT_FRAME1 0x20184E60
#define TOP_LEFT_FRAME2 0x201CB370
#define TOP_RIGHT_FRAME1 0x20282160
#define TOP_RIGHT_FRAME2 0x202C8670
#define SUB_FRAME1 0x202118E0
#define SUB_FRAME2 0x20249CF0 //539039968

// IO
#define STATE_3D_SLIDER 0x1FF81080
#define TIMER 0x10003000
#define HID 0x10146000 

void write_byte(int address, char byte);
void write_word(int address, int word);
void write_color(int address, char r, char g, char b);
int read_word(int address);
void* find_byte_sequence(char* sequence, int num, int base_address);
void paint_pixel(int x, int y, char r, char g, char b, int screen);
void paint_letter(unsigned char letter,int x,int y, char r, char g, char b, int screen);
void paint_word(char* word, int x,int y, char r, char g, char b, int screen);
void paint3Dword(char* word, int x,int y, char r, char g, char b,int offset3D);
int strlen(char* string); 
#endif

